////////////////////////////////////////////////////////////////////////////////
//
// Bav_API.h
//
// C/C++ header file for The Bat! Anti-Viris Plug-In API
//
////////////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
extern "C" {
#endif

// Return codes
#define	AVC_Error			-3
#define AVC_CantBeCured		-2
#define AVC_NotSupported	-1
#define AVC_OK				 0
#define AVC_VirusFound		 1
#define AVC_Suspicious		 2


// Function prototypes
int WINAPI BAV_Initialize(void);
int WINAPI BAV_Uninitialize(void);
int WINAPI BAV_ComNeeded(void);
int WINAPI BAV_GetName(TCHAR* Buf, int BufSize);
int WINAPI BAV_GetVersion(TCHAR* Buf, int BufSize);
int WINAPI BAV_ConfigNeeded(void);
int WINAPI BAV_Setup(void);
int WINAPI BAV_SetCfgData(void* Buf, int BufSize);
int WINAPI BAV_GetCfgData(void* Buf, int* BufSize);
int WINAPI BAV_GetStatus(void);
int WINAPI BAV_MemoryChecking(void);
int WINAPI BAV_FileChecking(void);
int WINAPI BAV_StreamChecking(void);
int WINAPI BAV_CheckMemory(void* Buf, int BufSize, TCHAR* Msg);
int WINAPI BAV_CureMemory(void* Buf, int* BufSize, TCHAR* Msg);
int WINAPI BAV_CheckFile(TCHAR* FileName, TCHAR* Msg);
int WINAPI BAV_CureFile(TCHAR* FileName, TCHAR* Msg);
int WINAPI BAV_CheckStream(IStream* InStream, TCHAR* Msg);
int WINAPI BAV_CureStream(IStream* InStream, IStream* OutStream, TCHAR* Msg);

#ifdef __cplusplus
}
#endif
