// DO NOT force specific message IDs here, let MC generate consecutive ones!!
// Also make sure you are not using any Severity or Facility codes!!
//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Create Log File
//
//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//


//
// MessageId: MSG_PATH
//
// MessageText:
//
//  BitDefender Command Line Scanner:
//
#define MSG_PATH                         0x00000001L

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Create Log File
//
//
// MessageId: MSG_CREATELOG
//
// MessageText:
//
//  Maintain &Log File
//
#define MSG_CREATELOG                    0x00000002L

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Limit Log File
//
//
// MessageId: MSG_LIMITLOG
//
// MessageText:
//
//  &Limit log file size to
//
#define MSG_LIMITLOG                     0x00000003L

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Cancel
//
//
// MessageId: MSG_CANCEL
//
// MessageText:
//
//  Cancel
//
#define MSG_CANCEL                       0x00000004L

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Browse
//
//
// MessageId: MSG_BROWSE
//
// MessageText:
//
//  &Browse...
//
#define MSG_BROWSE                       0x00000005L

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// View
//
//
// MessageId: MSG_VIEW
//
// MessageText:
//
//  &View
//
#define MSG_VIEW                         0x00000006L

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Clear
//
//
// MessageId: MSG_CLEAR
//
// MessageText:
//
//  &Clear
//
#define MSG_CLEAR                        0x00000007L

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Confirm Clear
//
//
// MessageId: MSG_CONFIRM_CLEAR
//
// MessageText:
//
//  Really clear log file?
//
#define MSG_CONFIRM_CLEAR                0x00000008L

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Warning
//
//
// MessageId: MSG_WARNING
//
// MessageText:
//
//  Warning: path to BitDefender command line scanner not set or invalid!
//
#define MSG_WARNING                      0x00000009L

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Not found
//
//
// MessageId: MSG_NOTFOUND
//
// MessageText:
//
//  <not found>
//
#define MSG_NOTFOUND                     0x0000000AL

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// About
//
//
// MessageId: MSG_ABOUT
//
// MessageText:
//
//  &About...
//
#define MSG_ABOUT                        0x0000000BL

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// About text
//
//
// MessageId: MSG_ABOUTTEXT
//
// MessageText:
//
//  BitDefender Free Edition Antivirus Plugin for The Bat!
//  
//       2005 Ralf Buschmann <caranthir2@gmx.de>
//
#define MSG_ABOUTTEXT                    0x0000000CL

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Signatures
//
//
// MessageId: MSG_SIGNATURES
//
// MessageText:
//
//  Virus Signatures
//
#define MSG_SIGNATURES                   0x0000000DL

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// End of static messages for dialog
//
//
// MessageId: MSG_MAXMESSAGE_NUMBER
//
// MessageText:
//
//  End
//
#define MSG_MAXMESSAGE_NUMBER            0x0000000EL

//////////////////////////////////////////////////////////////////////////////////////////////////
//
// Signatures
//
//
// MessageId: MSG_VERSIONS
//
// MessageText:
//
//  Total:		%1!u!
//  Date (GMT):	%2
//  Version:		%3
//
#define MSG_VERSIONS                     0x0000000FL

