////////////////////////////////////////////////////////////////////////////////
//
// BdLite.cpp
//
// The Bat! Antivirus Plugin for Softwin's Free BitDefender Lite edition
//
// Main module implementing DLL exports
//
//
// This is free software and source code, feel free to modify and distribute
// at your own risk.
//
// Original author: Ralf Buschmann (caranthir2@gmx.de)
//
// Version 1.0 (February 2, 2005)
//
//
//
////////////////////////////////////////////////////////////////////////////////
#include "BdLite.h"

HINSTANCE	hInstance = NULL;

TCHAR	*szBdc = NULL, *szBdcDir = NULL;
DWORD	dwLogging = 1;
DWORD	dwLogMax = 0;

extern	TCHAR				*szLogfile;
extern	CRITICAL_SECTION	csScanner;

TCHAR	*MsgTable[MSG_MAXMESSAGE_NUMBER];

////////////////////////////////////////////////////////////////////////////////
//
//	DllMain()
//
//  DLL entry point
//
////////////////////////////////////////////////////////////////////////////////
BOOL APIENTRY DllMain(HINSTANCE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			hInstance = hModule;
			break;

		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }

    return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
//
//	EnableDisableControls()
//
//  Enables/disables controls based on checkbox settings
//
////////////////////////////////////////////////////////////////////////////////
void EnableDisableControls(HWND hWnd)
{
	if (BST_UNCHECKED == IsDlgButtonChecked(hWnd, IDC_LOGFILE))
	{
		EnableWindow(GetDlgItem(hWnd, IDC_LIMITLOG), FALSE);
		EnableWindow(GetDlgItem(hWnd, IDC_EDIT), FALSE);
		EnableWindow(GetDlgItem(hWnd, IDC_SPIN), FALSE);
		EnableWindow(GetDlgItem(hWnd, IDC_TEXT), FALSE);
		EnableWindow(GetDlgItem(hWnd, IDC_VIEW), FALSE);
		EnableWindow(GetDlgItem(hWnd, IDC_CLEAR), FALSE);
	}
	else
	{
		EnableWindow(GetDlgItem(hWnd, IDC_LIMITLOG), TRUE);

		if (BST_UNCHECKED == IsDlgButtonChecked(hWnd, IDC_LIMITLOG))
		{
			EnableWindow(GetDlgItem(hWnd, IDC_EDIT), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_SPIN), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_TEXT), FALSE);
		}
		else
		{
			EnableWindow(GetDlgItem(hWnd, IDC_EDIT), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_SPIN), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_TEXT), TRUE);
		}
		
		if (INVALID_FILE_ATTRIBUTES == GetFileAttributes(szLogfile))
		{
			EnableWindow(GetDlgItem(hWnd, IDC_VIEW), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_CLEAR), FALSE);
		}
		else
		{
			EnableWindow(GetDlgItem(hWnd, IDC_VIEW), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_CLEAR), TRUE);
		}
	}
}

////////////////////////////////////////////////////////////////////////////////
//
//	DialogProc()
//
//  Config dialog function
//
////////////////////////////////////////////////////////////////////////////////
BOOL CALLBACK DialogProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		// This message means the dialog is started but not yet visible.
		case WM_INITDIALOG:
		{
			struct _MSGMAP {
				int idControl;
				int idMsg;
			} MsgMap[] = {	
				{IDC_PATHBOX, MSG_PATH},
				{IDC_BROWSE, MSG_BROWSE},
				{IDC_LOGFILE, MSG_CREATELOG},
				{IDC_LIMITLOG, MSG_LIMITLOG},
				{IDC_VIEW, MSG_VIEW},
				{IDC_CLEAR, MSG_CLEAR},
				{IDC_SIGBOX, MSG_SIGNATURES},
				{IDCANCEL, MSG_CANCEL}
			};

			RECT rcDlg, rcParent;
			int nWidth, nHeight, nX, nY, nSignatures = 0;
			HMENU hMenu;
			TCHAR *szUpdateFile = NULL, *p;
			FILE *File = NULL;
			TCHAR szBuf[MAX_BUFFER] = {0}, szDate[255] = {0}, szVer[255] = {0};
			time_t time = 0;
			struct tm *date;

			void *lpArgs[3] = {(int*)nSignatures, szDate, szVer};
			
			lstrcpy(szDate, TEXT("n/a"));
			lstrcpy(szVer, TEXT("n/a"));

			// Set controls text
			for (int i = 0; i < (sizeof(MsgMap) / sizeof(_MSGMAP)); i++)
				SetDlgItemText(hWnd, MsgMap[i].idControl, MsgTable[MsgMap[i].idMsg]);

			SetWindowText(hWnd, PLUGIN_NAME);
			
			// Center above parent
			GetWindowRect(GetParent(hWnd), &rcParent);
			GetWindowRect(hWnd, &rcDlg);

			nWidth = rcDlg.right - rcDlg.left;
			nHeight = rcDlg.bottom - rcDlg.top;

			if ((nWidth  < (rcParent.right - rcParent.left)) &&
				(nHeight < (rcParent.bottom - rcParent.top)))
			{
				nX = rcParent.left + ((rcParent.right - rcParent.left -  nWidth) / 2);
				nY = rcParent.top + ((rcParent.bottom - rcParent.top -  nHeight) / 2);

				// Finally, move the dialog.
				SetWindowPos(hWnd, NULL, nX, nY, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
			}

			// Init various controls and system menu
			SendMessage(hWnd, WM_SETICON, ICON_SMALL, (LPARAM)LoadIcon(hInstance, MAKEINTRESOURCE(IDI_CAPTION)));

			GetSystemMenu(hWnd, TRUE);
			hMenu = NULL;
			if (NULL != (hMenu = GetSystemMenu(hWnd, FALSE)))
			{
				InsertMenu(hMenu, SC_CLOSE, MF_BYCOMMAND | MF_STRING, SC_ABOUT, MsgTable[MSG_ABOUT]);
				InsertMenu(hMenu, SC_CLOSE, MF_BYCOMMAND | MF_SEPARATOR, 0, NULL);
			}

			DrawMenuBar(hWnd);

			SetWindowLong(
				GetDlgItem(hWnd, IDC_PATH),
				GWL_STYLE,
				GetWindowLong(GetDlgItem(hWnd, IDC_PATH), GWL_STYLE) | SS_PATHELLIPSIS);

			if (szBdc)
				SetDlgItemText(hWnd, IDC_PATH, szBdc);
			else
				SetDlgItemText(hWnd, IDC_PATH, MsgTable[MSG_NOTFOUND]);

			if (dwLogging)
				CheckDlgButton(hWnd, IDC_LOGFILE, BST_CHECKED);

			SendMessage(GetDlgItem(hWnd, IDC_SPIN), UDM_SETRANGE, 0, MAKELONG(999, 0));
			SendMessage(GetDlgItem(hWnd, IDC_SPIN), UDM_GETPOS, 0, 0);
			SetDlgItemInt(hWnd, IDC_EDIT, dwLogMax / 1024, FALSE);
			SendMessage(GetDlgItem(hWnd, IDC_SPIN), UDM_GETPOS, 0, 0);
			if (dwLogMax)
				CheckDlgButton(hWnd, IDC_LIMITLOG, BST_CHECKED);

			EnableDisableControls(hWnd);

			// Get update info if available
			if (szBdcDir && (NULL != (szUpdateFile = (TCHAR*)LocalAlloc(LPTR, ((lstrlen(szBdcDir) + 1) * sizeof(TCHAR)) + sizeof(UPDATE_TXT)))))
			{
				_stprintf(szUpdateFile, TEXT("%s%s"), szBdcDir, UPDATE_TXT);
				if (NULL != (File = _tfopen(szUpdateFile, TEXT("rt"))))
				{
					while (_fgetts(szBuf, MAX_BUFFER, File))
					{
						p = szBuf + lstrlen(szBuf) - 1;
						while ((p > szBuf) && ((*p == '\r') || (*p == '\n') || (*p == ' ')))
						{
							*p = 0;
							p--;
						}
						if (_tcsstr(szBuf, TEXT("Signature number: ")))
							nSignatures = _ttoi(_tcsstr(szBuf, TEXT(":")) + 2);

						if (_tcsstr(szBuf, TEXT("Update time GMT: ")))
							time = _ttoi(_tcsstr(szBuf, TEXT(":")) + 2);

						if (_tcsstr(szBuf, TEXT("Version: ")))
							lstrcpyn(szVer, _tcsstr(szBuf, TEXT(":")) + 2, sizeof(szVer) / sizeof(TCHAR));
					}
					
					fclose(File);

					if (time)
					{
						date = localtime(&time);
						_stprintf(szDate, TEXT("%02d.%02d.%02d %02d:%02d"),
							date->tm_mday, date->tm_mon + 1, date->tm_year + 1900, date->tm_hour, date->tm_min);
					}

					p = NULL;
					lpArgs[0] = (int*)nSignatures;
					
					if (FormatMessage(
						FORMAT_MESSAGE_ALLOCATE_BUFFER |
						FORMAT_MESSAGE_FROM_HMODULE    |
						FORMAT_MESSAGE_ARGUMENT_ARRAY,
						hInstance,
						MSG_VERSIONS,
						MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
						(LPTSTR)&p,
						0,
						(va_list*)lpArgs
						))
					{
						SetDlgItemText(hWnd, IDC_STATS, p);
						LocalFree(p);
					}
				}

				LocalFree(szUpdateFile);
			}

			break;
		}

		case  WM_SYSCOMMAND:
		{
			if (wParam == SC_ABOUT)
				MessageBox(hWnd,
					MsgTable[MSG_ABOUTTEXT],
					PLUGIN_NAME, MB_OK);

			break;
		}


		case WM_COMMAND:
		{
			switch (LOWORD(wParam))
		    {
				case IDC_BROWSE:
				{
					OPENFILENAME ofn;
					TCHAR szFile[MAX_BUFFER] = {0};
					
					ZeroMemory(&ofn, sizeof(OPENFILENAME));

					ofn.lStructSize = sizeof(OPENFILENAME);
					ofn.Flags       = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
					ofn.hwndOwner   = hWnd;
					ofn.lpstrFilter = TEXT("bdc\0bdc.exe\0*.exe\0*.exe\0\0");
					ofn.lpstrFile   = szFile;
					ofn.lpstrDefExt = TEXT("exe");
					ofn.nMaxFile    = MAX_BUFFER;

					if (szBdc)
						lstrcpyn(szFile, szBdc, MAX_BUFFER);

					if (GetOpenFileName(&ofn))
					{
						if (szBdc)
						{
							LocalFree(szBdc);
							szBdc = NULL;
						}

						if (szBdcDir)
						{
							LocalFree(szBdcDir);
							szBdcDir = NULL;
						}
						
						if ((szBdc = (TCHAR*)LocalAlloc(LPTR, (lstrlen(szFile) + 1) * sizeof(TCHAR))) &&
							(szBdcDir = (TCHAR*)LocalAlloc(LPTR, ofn.nFileOffset * sizeof(TCHAR))))
						{
							lstrcpy(szBdc, szFile);
							lstrcpyn(szBdcDir, szFile, ofn.nFileOffset);
							SetDlgItemText(hWnd, IDC_PATH, szBdc);
						}
						else if (szBdc)
						{
							// Don't leak memory
							LocalFree(szBdc);
							szBdc = NULL;
						}
					}

					break;
				}
				case IDOK:
				{
					if (!szBdc && (IDCANCEL == MessageBox(hWnd, MsgTable[MSG_WARNING], PLUGIN_NAME, MB_OKCANCEL | MB_ICONEXCLAMATION)))
						break;
					
					if (BST_UNCHECKED == IsDlgButtonChecked(hWnd, IDC_LOGFILE))
						dwLogging = 0;

					if (!dwLogging)
						InitLogFile(FALSE);

					if (BST_UNCHECKED == IsDlgButtonChecked(hWnd, IDC_LIMITLOG))
						dwLogMax = 0;
					else
						dwLogMax = 1024 * GetDlgItemInt(hWnd, IDC_EDIT, NULL, FALSE);

					if (szBdc)
						RegSetRegValue(HKEY_CURRENT_USER, PLUGIN_KEY, BDC,
							REG_SZ, (BYTE*)szBdc, (lstrlen(szBdc) + 1) * sizeof(TCHAR));

					RegSetRegValue(HKEY_CURRENT_USER, PLUGIN_KEY, LOGGING,
						REG_DWORD, (BYTE*)&dwLogging, sizeof(DWORD));

					RegSetRegValue(HKEY_CURRENT_USER, PLUGIN_KEY, LOGSIZE,
						REG_DWORD, (BYTE*)&dwLogMax, sizeof(DWORD));

					EndDialog(hWnd, 0);

					break;
				}

				case IDCANCEL:
				{
					if (!szBdc && (IDCANCEL == MessageBox(hWnd, MsgTable[MSG_WARNING], PLUGIN_NAME, MB_OKCANCEL | MB_ICONEXCLAMATION)))
						break;

					EndDialog(hWnd, 1);
					break;
				}

				case IDC_VIEW:
				{
					ShellExecute(hWnd, TEXT("open"), TEXT("notepad.exe"), szLogfile, NULL, SW_SHOW);
					break;
				}

				case IDC_CLEAR:
				{
					if (IDYES == MessageBox(hWnd, MsgTable[MSG_CONFIRM_CLEAR], PLUGIN_NAME, MB_YESNO | MB_ICONQUESTION))
					{
						InitLogFile(FALSE, TRUE);
						InitLogFile(TRUE);
					}

					break;
				}

				case IDC_LOGFILE:
				case IDC_LIMITLOG:
				{
					EnableDisableControls(hWnd);
					break;
				}
			}

			break;
		}
	}

	return FALSE;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_Initialize()
//
//	This function is called upon initialization of the Plug-in. During The Bat!
//	execution, it is called just once right after the Plug-in module is loaded.
//	Use BAV_Initialize to initialize all internal data for proper functioning
//	of the Plug-in.
//
//	Return values:
//
//	AVC_OK				function completed successfully
//	AVC_Error			a failure occurred during execution of the function 
//	AVC_NotSupported	function is not supported 
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_Initialize(void)
{
	DWORD dwSize, *dwTmp;
	TCHAR *szDir = NULL, *p;

	// Try to get location from Softwin's key first
	if (ERROR_SUCCESS == RegGetRegValue(
		HKEY_LOCAL_MACHINE, SOFTWIN_KEY, BDC,
		NULL, (BYTE**)&szDir, &dwSize))
	{
		if (szDir[lstrlen(szDir) - 1] == '\\')
			szDir[lstrlen(szDir) - 1] = 0;

		if (FormatMessage(
			FORMAT_MESSAGE_ALLOCATE_BUFFER	|
			FORMAT_MESSAGE_FROM_STRING		|
			FORMAT_MESSAGE_ARGUMENT_ARRAY,
			TEXT("%1\\bdc.exe"),
			0,
			0,
			(LPTSTR)&szBdc,
			0,
			&szDir
			))
		{
			if (INVALID_FILE_ATTRIBUTES == GetFileAttributes(szBdc))
			{
				LocalFree(szBdc);
				szBdc = NULL;
			}
		}

		LocalFree(szDir);
		szDir = NULL;
	}
	
	// Try saved location
	if (!szBdc && (ERROR_SUCCESS == RegGetRegValue(
			 HKEY_CURRENT_USER, PLUGIN_KEY, BDC,
			 NULL, (BYTE**)&szBdc, &dwSize)))
	{
		if (INVALID_FILE_ATTRIBUTES == GetFileAttributes(szBdc))
		{
			LocalFree(szBdc);
			szBdc = NULL;
		}
	}
	// Try default in %COMMONPROGRAMFILES%
	if (!szBdc && (ERROR_SUCCESS == RegGetRegValue(
		HKEY_LOCAL_MACHINE, TEXT("SOFTWARE\\Microsoft\\Windows\\CurrentVersion"), TEXT("CommonFilesDir"),
		NULL, (BYTE**)&szDir, &dwSize)))
	{
		if (szDir[lstrlen(szDir) - 1] == '\\')
			szDir[lstrlen(szDir) - 1] = 0;

		if (FormatMessage(
			FORMAT_MESSAGE_ALLOCATE_BUFFER	|
			FORMAT_MESSAGE_FROM_STRING		|
			FORMAT_MESSAGE_ARGUMENT_ARRAY,
			TEXT("%1\\Softwin\\BitDefender Scan Server\\bdc.exe"),
			0,
			0,
			(LPTSTR)&szBdc,
			0,
			&szDir
			))
		{
			if (INVALID_FILE_ATTRIBUTES == GetFileAttributes(szBdc))
			{
				LocalFree(szBdc);
				szBdc = NULL;
			}
		}

		LocalFree(szDir);
		szDir = NULL;
	}

	if  (szBdc && (NULL != (p = _tcsrchr(szBdc, '\\'))) &&
		(NULL != (szBdcDir = (TCHAR*)LocalAlloc(LPTR, (lstrlen(szBdc) + 1) * sizeof(TCHAR)))))
	{
		lstrcpyn(szBdcDir, szBdc, p - szBdc + 1);
	}

	// Get Logging Options
	if (ERROR_SUCCESS == RegGetRegValue(
		HKEY_CURRENT_USER, PLUGIN_KEY, LOGGING,
		NULL, (BYTE**)&dwTmp, &dwSize))
	{
		dwLogging = *dwTmp;
		LocalFree(dwTmp);
	}

	if (ERROR_SUCCESS == RegGetRegValue(
		HKEY_CURRENT_USER, PLUGIN_KEY, LOGSIZE,
		NULL, (BYTE**)&dwTmp, &dwSize))
	{
		dwLogMax = *dwTmp;
		LocalFree(dwTmp);
	}

	if (dwLogging)
	{
		InitLogFile(TRUE);
		LogMessage(TEXT("%s PlugIn initialization complete"), PLUGIN_NAME);
		if (!szBdc)
			LogMessage(TEXT("Warning: unable to locate BitDefender command line scanner"));
	}

	// Load messages
	ZeroMemory(MsgTable, sizeof(MsgTable));
	for (int i = 1; i < MSG_MAXMESSAGE_NUMBER; i++)
	{
		FormatMessage(
			FORMAT_MESSAGE_ALLOCATE_BUFFER |
			FORMAT_MESSAGE_IGNORE_INSERTS  |
			FORMAT_MESSAGE_FROM_HMODULE,
			hInstance,
			i,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			(LPTSTR)&MsgTable[i],
			0,
			NULL
			);
	}

	// Initialize critical section for command line scanner
	InitializeCriticalSection(&csScanner);
	
	// Just in case
	InitCommonControls();
	
	return AVC_OK;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_Uninitialize()
//
//	This function is called once before the Plug-in is unloaded from memory. Use
//	BAV_Uninitialize for cleaning up memory, temporary files, etc.
//
//	Return values:
//
//	AVC_OK				function completed successfully
//	AVC_Error			a failure occurred during execution of the function 
//	AVC_NotSupported	function is not supported 
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_Uninitialize(void)
{
	if (szBdc)
	{
		RegSetRegValue(HKEY_CURRENT_USER, PLUGIN_KEY, BDC,
			REG_SZ, (BYTE*)szBdc, (lstrlen(szBdc) + 1) * sizeof(TCHAR));

		LocalFree(szBdc);
	}

	if (szBdcDir)
		LocalFree(szBdcDir);

	DeleteCriticalSection(&csScanner);

	if (dwLogging)
	{
		LogMessage(TEXT("%s PlugIn shutdown complete\n"), PLUGIN_NAME);
		InitLogFile(FALSE);
	}

	// Free Messages
	for (int i = 1; i < MSG_MAXMESSAGE_NUMBER; i++)
	{
		if (MsgTable[i])
			LocalFree(MsgTable[i]);
	}

	return AVC_OK;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_ComNeeded()
//
//	This function is called to determine whether the Plug-in requires COM
//	subsystem initialisation, i.e. call to CoInitialize must be made before
//	using functions of the Plug-in in a thread.
//
//	Return values:
//
//	AVC_OK				the Plug-in requires COM subsystem to be initialised 
//	AVC_Error			the Plug-in does not require COM  
//	AVC_NotSupported	function is not supported 
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_ComNeeded(void)
{

	return AVC_Error;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_GetName()
//
//	This function is called in order to retrieve the name of the Plug-in.
//
//	Return values:
//
//	Any positive value	the number of bytes written in the ABuf or the required
//						buffer size, the function completed successfully
//	AVC_Error			a failure occurred during execution of the function
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_GetName(TCHAR* Buf, int BufSize)
{
	if ((Buf == NULL) || (BufSize < sizeof(TCHAR)))
		return sizeof(PLUGIN_NAME);

	lstrcpyn(Buf, PLUGIN_NAME, BufSize / sizeof(TCHAR));

	return (BufSize < sizeof(PLUGIN_NAME)) ? BufSize : sizeof(PLUGIN_NAME);
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_GetVersion()
//
//	This function is called in order to retrieve the version name of the Plug-in.
//	The version name may contain additional information like number of records
//	in virus database etc.
//
//	Return values:
//
//	Any positive value	the number of bytes written in the ABuf or the required
//						buffer size, the function completed successfully
//	AVC_Error			a failure occurred during execution of the function
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_GetVersion(TCHAR* Buf, int BufSize)
{
	if ((Buf == NULL) || (BufSize < sizeof(TCHAR)))
		return sizeof(PLUGIN_VERSION);

	lstrcpyn(Buf, PLUGIN_VERSION, BufSize / sizeof(TCHAR));

	return (BufSize < sizeof(PLUGIN_VERSION)) ? BufSize : sizeof(PLUGIN_VERSION);
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_ConfigNeeded()
//
//	This function is called to determine whether the Plug-in requires
//	additional configuration.
//
//	Return values:
//
//	AVC_OK				the Plug-in can be configured within The Bat!
//	AVC_Error			the Plug-in cannot be configured within The Bat!
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_ConfigNeeded(void)
{

	return AVC_OK;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_Setup()
//
//	This function is called for fine-tuning the Plug-in from The Bat! Anti-virus
//	configuration page by clicking the Configure button or right after
//	installing the Plug-in. The BAV_Setup can be called by The Bat! only if the
//	BAV_ConfigNeeded returned AVC_OK. The handle of the calling window can be
//	retrieved by the GetActiveWindow Win32 API function.
//
//	Return values:
//
//	AVC_OK				function completed successfully
//	AVC_Error			a failure occurred during execution of the function 
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_Setup(void)
{
	DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG), GetActiveWindow(), DialogProc, NULL);

	return AVC_OK;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_SetCfgData()
//
//	This function is used for passing Plug-in configuration data stored in the
//	Plug-in configuration file. Usually, AV Plug-ins do not require storing any
//	information separately from AV software, but sometimes it may be needed for
//	fine-tuning. There are no any special requirements about the configuration
//	data format; it is treated as a binary buffer that may contain any
//	characters.
//
//	The BAV_SetCfgData is called when the Plug-in is loaded and initialised at
//	the program's start-up.
//
//  NOTE: Currently The Bat! never seems to call this function!
//
//	Return values:
//
//	AVC_OK				function completed successfully
//	AVC_Error			a failure occurred during execution of the function 
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_SetCfgData(void* Buf, int BufSize)
{

	return AVC_NotSupported;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_GetCfgData()
//
//	This function is used for retrieving Plug-in configuration data after the
//	Plug-in is configured using the BAV_Setup function in order to store the
//	data in the Plug-in configuration file. Usually, AV Plug-ins do not require
//	storing any information separately from AV software, but sometimes it may
//	be needed for fine-tuning. There are no any special requirements about the
//	configuration data format; it is treated as a binary buffer that may
//	contain any characters.
//
//	The BAV_GetCfgData is called when the BAV_Setup function returns AVC_OK.
//
//	Return values:
//
//	AVC_OK				function completed successfully
//	AVC_Error			a failure occurred during execution of the function
//	AVC_NotSupported	function is not supported
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_GetCfgData(void* Buf, int* BufSize)
{

	return AVC_NotSupported;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_GetStatus()
//
//	This function is called to determine whether the Plug-in is functioning
//	properly.
//
//	Return values:
//
//	AVC_OK				function completed successfully
//	AVC_Error			a failure occurred during execution of the function 
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_GetStatus(void)
{
	if (szBdc)
		return AVC_OK;
	else
		return AVC_Error;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_MemoryChecking()
//
//	This function is called to determine whether the Plug-in supports memory
//	checking, i.e. BAV_CheckMemory and BAV_CureMemory are implemented. Memory
//	checking means files will be passed to checking functions as continuous
//	memory block which may require a lot of memory. While using this option is
//	not desirable in general, it may be suitable for secure versions of
//	The Bat! in case AV software does not support stream checking (so the data
//	is not stored on disk insecurely)
//
//	Return values:
//
//	AVC_OK				the Plug-in supports memory checking
//	AVC_Error			the Plug-in does not support memory checking
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_MemoryChecking(void)
{

	return AVC_Error;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_FileChecking()
//
//	This function is called to determine whether the Plug-in supports file
//	checking, i.e. BAV_CheckFile and BAV_CureFile are implemented.
//
//	Return values:
//
//	AVC_OK				the Plug-in supports file checking
//	AVC_Error			the Plug-in does not support file checking
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_FileChecking(void)
{

	return AVC_OK;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_StreamChecking()
//
//	This function is called to determine whether the Plug-in supports stream
//	checking, i.e. BAV_CheckStream and BAV_CureStream are implemented. This is
//	the most preferred option because it provides maximum flexibility and
//	security.
//
//	Return values:
//
//	AVC_OK				the Plug-in supports stream checking
//	AVC_Error			the Plug-in does not support stream checking
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_StreamChecking(void)
{

	return AVC_Error;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_CheckMemory()
//
//	This function is called in order to check a memory block for viruses.
//
//	Return values:
//
//	AVC_OK				the object is clean
//	AVC_VirusFound		the object is infected
//	AVC_Suspicious     	the object is found as suspicious
//	AVC_Error			an error occurred while performing this function
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_CheckMemory(void* Buf, int BufSize, TCHAR* Msg)
{

	return AVC_NotSupported;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_CureMemory()
//
//	This function is called in order to check a memory block for viruses and
//	try to remove viruses (if any found).
//
//	Return values:
//
//	AVC_OK				the object is clean
//	AVC_VirusFound    	the object is infected
//	AVC_Suspicious     	the object is found as suspicious
//	AVC_CantBeCured 	the object is infected but cannot be cleaned from virus(es)
//	AVC_Error			an error occurred while performing this function
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_CureMemory(void* Buf, int* BufSize, TCHAR* Msg)
{

	return AVC_NotSupported;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_CheckFile()
//
//	This function is called in order to check a file for viruses
//
//	Return Values:
//
//	AVC_OK				the object is clean
//	AVC_VirusFound    	the object is infected
//	AVC_Suspicious      the object is found as suspicious
//	AVC_Error			an error occurred while performing this function
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_CheckFile(TCHAR* FileName, TCHAR* Msg)
{
	if (szBdc == NULL)
		return AVC_Error;

	return ScanFile(FileName, Msg, FALSE);
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_CureFile()
//
//	This function is called in order to check a file for viruses and clean the
//	file in case a virus is found.
//
//	Return values:
//
//	AVC_OK				the object is clean
//	AVC_VirusFound    	the object is infected
//	AVC_Suspicious     	the object is found as suspicious
//	AVC_CantBeCured 	the object is infected but cannot be cleaned from virus(es)
//	AVC_Error			an error occurred while performing this function
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_CureFile(TCHAR* FileName, TCHAR* Msg)
{
	if (szBdc == NULL)
		return AVC_Error;

	return ScanFile(FileName, Msg, TRUE);
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_CheckStream()
//
//	This function is called in order to check a stream object for viruses.
//
//	Return values:
//
//	AVC_OK				the object is clean
//	AVC_VirusFound    	the object is infected
//	AVC_Suspicious     	the object is found as suspicious
//	AVC_Error			an error occurred while performing this function
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_CheckStream(IStream* InStream, TCHAR* Msg)
{

	return AVC_NotSupported;
}

////////////////////////////////////////////////////////////////////////////////
//
//	BAV_CureStream()
//
//	This function is called in order to check a stream object for viruses and
//	clean the stream in case a virus is found.
//
//	Return values:
//
//	AVC_OK				the object is clean
//	AVC_VirusFound    	the object is infected
//	AVC_Suspicious      the object is found as suspicious
//	AVC_CantBeCured 	the object is infected but cannot be cleaned from virus(es)
//	AVC_Error			an error occurred while performing this function
//	AVC_NotSupported	function is not supported
//
////////////////////////////////////////////////////////////////////////////////
int WINAPI BAV_CureStream(IStream* InStream, IStream* OutStream, TCHAR* Msg)
{

	return AVC_NotSupported;
}